/* Copyright (c) 2002 Sebastian Tusk.  All rights reserved.
 * 
 * $Id: configure.in,v 1.11 2001/06/11 19:16:25 gtrubetskoy Exp $ */
 
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "apr_buckets.h"
#include "apr_strings.h"
#include "ap_config.h"
#include "util_filter.h"
#include "httpd.h"
#include "http_config.h"
#include "http_request.h"
#include "http_core.h"
#include "http_protocol.h"
#include "http_log.h"
#include "http_main.h"
#include "util_script.h"
#include "http_core.h"

module AP_MODULE_DECLARE_DATA scrmable_module;

typedef struct {
	apr_table_t* scrmableoptions;
} mod_scrmable_config; 

// scrmable memory management
apr_pool_t *mod_scrmable_g_MemPool = NULL;

typedef struct mod_scrmable_struct {
	apr_bucket_brigade *bb;
	apr_bucket_alloc_t *ba;
	ap_filter_t *f;
} mod_scrmable_struct;

void* mod_scrmable_MemAlloc( size_t size ) {
	void *p;

	p = apr_pcalloc(mod_scrmable_g_MemPool, size + sizeof( size_t ) );

	if ( p ) {
		*(size_t*)p = size;
		p = (size_t*)p + 1;
	}
	return p;
}

char *upperstring(char *cpString) {
	int iLen, i;
	char *cpResult;
	
	iLen = strlen(cpString);
	cpResult =  (char *)mod_scrmable_MemAlloc(iLen+1);

	for (i=0; i<iLen; i++) {
		cpResult[i] = toupper(cpString[i]);
	}
	cpResult[i] = 0;

	return cpResult;
}

void stringappend(char *cpString, char *cpAppend, int iSep) {
	char sep[2];
	if (iSep > 0) {
		sep[0] = iSep;
		sep[1] = 0;
		strcat(cpString, cpAppend);
		strcat(cpString, sep);
	} else {
		strcat(cpString, cpAppend);
	}
}

char *scramble (char *sText, int iLen) {
//	return (sText);

	char *lc1, *lc2, cFirst, cLast, *cpMiddle, *cpResult;;
	int iCount=0, iMiddle = 0, iIndex = 0, i;
	char c;

	cpResult = (char *)mod_scrmable_MemAlloc(iLen+1);	
	lc1 = (char *)mod_scrmable_MemAlloc(iLen+1);
	lc2 = (char *)mod_scrmable_MemAlloc(iLen+1);
	cpMiddle = (char *)mod_scrmable_MemAlloc(iLen+1);
	
	for (i=0; i<iLen; i++){
		if (i==0) {
			cFirst = sText[i];
		}
		else if (i==(iLen-1)) {
			cLast = sText[i];
		}
		else{
			cpMiddle[iMiddle++] = sText[i];
		}
		lc1[i] = '0';
	}

	for (i=0; i<(iLen-2); i++){
		c = cpMiddle[i];
	        while (iCount < (iLen-2)) {
			iIndex = (rand()%(iLen-2));
			if (lc1[iIndex] == '0') {
				lc1[iIndex] = '1';
				lc2[iIndex] = cpMiddle[iCount];
				iCount++;
			}
		}
	}
	iMiddle = 0;
	for (i=0; i<iLen; i++) {
		if (i==0) {
			cpResult[i] = cFirst;
		}
		else if (i==(iLen-1)) {
			cpResult[i] = cLast;
		}
		else {
			cpResult[i] = lc2[iMiddle++];
		}
	}
	cpResult[iLen] = 0;
	return cpResult;
}

char *scrmable_text(char *sText, uint iLen) {
	//char *sText="<div class=schaap>koetjeboe schaap&nbps;koe</div>";
	char *cpScrambled, *cpTemp, *cpScriptTag, *cpTag;
        int iState = 0, iIndex = 0, iWordIndex=0, i, iSkip = 0, iTag = 0, iTagIndex=0, iScript = 0;
	
	srand( (unsigned)time(NULL));
	
	cpScrambled = (char *)mod_scrmable_MemAlloc(iLen+1);
	cpTemp = (char *)mod_scrmable_MemAlloc(iLen+1);
	cpTag = (char *)mod_scrmable_MemAlloc(iLen+1);
	cpScriptTag = (char *)mod_scrmable_MemAlloc(10);
	
	for (i=0; i <  iLen; i++) {
		if ((iWordIndex > 0) && ((sText[i] == '<') || (sText[i] == '&'))) {
			cpTemp[iWordIndex] = 0;
			cpTemp = scramble(cpTemp, iWordIndex);
			//printf ("scambled word: %s\n", cpTemp);
			stringappend(cpScrambled, cpTemp, -1);
			iWordIndex = 0;
		}
		if (iSkip) {
			iSkip = 0;
		}

		if (iTag) {
			cpTag[iTagIndex++] = sText[i];
		}
		if (sText[i] == '<') {
			iState = 1;
			iTag = 1;
		}
		if (sText[i] == '>') {
			iState = 0;
			iSkip = 1; // skip this char
			iTag = 0;
			cpTag[iTagIndex] = 0;
			strncpy(cpScriptTag, cpTag, 6);
			cpScriptTag[6] = 0;
			cpScriptTag = upperstring(cpScriptTag);
			if (strcmp(cpScriptTag, "SCRIPT") == 0) {
				iScript = 1;
			}
			if (strcmp(cpScriptTag, "/SCRIP") == 0) {
				iScript = 0;
			}
			
			iTagIndex = 0;
		}
		if (sText[i]  == '&') {
			iState = 2;
		}
		if ((sText[i] == ';') && (iState == 2)) {
			iState =  0;
			iSkip = 1; //skip this char
		}
		if ((iState > 0) || (iSkip == 1) || (iScript == 1)) {
			// just copy chars.
			cpScrambled[i] = sText[i];
		} else {
			// fill temp string than scrable it
			// if is alfa ofzo
			if (((sText[i] >= 'a') && (sText[i] <= 'z')) || ((sText[i] >= 'A') && (sText[i] <= 'Z'))) {
				cpTemp[iWordIndex++] = sText[i];
				
				// last char in string?
				if (i == iLen-1) {
					cpTemp[iWordIndex] = 0;
					stringappend(cpScrambled, cpTemp, -1);
				}
				
			} else {
				cpTemp[iWordIndex] = 0;
				cpTemp = scramble(cpTemp, iWordIndex);
				//printf ("scrambled word: %s\n", cpTemp);
				stringappend(cpScrambled, cpTemp, sText[i]);
				iWordIndex = 0;
			}
		}
	}
	cpScrambled[iLen] = 0;
	return cpScrambled;
}

static int mod_scrmable_filter(ap_filter_t *f, apr_bucket_brigade *bb) {
	mod_scrmable_struct *ctx = f->ctx;
	apr_bucket *e;
	apr_pool_t *p = f->r->pool;
	char *word1 = NULL, *word2 = NULL;
	char *cpScrmabled;

	mod_scrmable_g_MemPool = f->r->pool;
	
	if (ctx == NULL) {
		mod_scrmable_config *cfg = ap_get_module_config(f->r->per_dir_config, &scrmable_module);
	
		f->ctx = ctx = apr_pcalloc(f->r->pool, sizeof(*ctx));
		ctx->ba = apr_bucket_alloc_create(f->r->pool);
		ctx->bb = apr_brigade_create(f->r->pool, ctx->ba);
		ctx->f = f;
	}

    for (e = APR_BRIGADE_FIRST(bb);
         e != APR_BRIGADE_SENTINEL(bb);
         e = APR_BUCKET_NEXT(e)) {
		const char *str;
		apr_size_t len;
		
		if (APR_BUCKET_IS_EOS(e)) {
			cpScrmabled = scrmable_text(str, len);

			ap_fputstrs(f->next, ctx->bb, cpScrmabled, NULL );
		
			APR_BUCKET_REMOVE(e);
			APR_BRIGADE_INSERT_TAIL(ctx->bb, e);
			ap_pass_brigade(f->next, ctx->bb);
			
			mod_scrmable_g_MemPool = NULL;
			
			return APR_SUCCESS;
		}
		apr_bucket_read(e, &str, &len, APR_NONBLOCK_READ);
		APR_BUCKET_REMOVE(e);
	}
	
	mod_scrmable_g_MemPool = NULL;
	
	return APR_SUCCESS;
}

static void mod_scrmable_register_hook(apr_pool_t *p)
{
    ap_register_output_filter("SCRMABLE", mod_scrmable_filter, NULL, AP_FTYPE_CONTENT_SET);
}

static void *mod_scrmable_create_dirconfig(apr_pool_t *p, char *dir)
{
	// module config
	mod_scrmable_config* cfg;
	
	cfg = (mod_scrmable_config*)apr_pcalloc(p, sizeof(mod_scrmable_config));

	cfg->scrmableoptions = apr_table_make(p, 4);

	return cfg;
}

static const char *set_mod_scrmable_option(cmd_parms *parms, void *mconfig, const char *w1, const char *w2) {
	mod_scrmable_config* cfg = (mod_scrmable_config*)mconfig;
	
	apr_table_set( cfg->scrmableoptions, w1, w2 );

	return NULL;
}

static const command_rec mod_scrmable_directives[] =
{
	AP_INIT_TAKE2(
		"ScrmableOption",
		set_mod_scrmable_option,
		NULL,
		ACCESS_CONF|OR_OPTIONS,
		"ScrmableOption name value"
	),
	{NULL}
};

module AP_MODULE_DECLARE_DATA scrmable_module = 
{
    STANDARD20_MODULE_STUFF,
    mod_scrmable_create_dirconfig,			/* create per-directory config structure */
    NULL,        		/* merge per-directory config structures */
    NULL,			/* create per-server config structure */
    NULL,			/* merge per-server config structures */
    mod_scrmable_directives,			/* command apr_table_t */
    mod_scrmable_register_hook		/* register hooks */
};

